/*
 *      CONSIDER 4 BLOCKS, WITH 4 THREADS/BLOCS
 *
*/
#include "tomtom.h"
__global__ void nupspin(double **A, int *a)
{
	int x = threadIdx.x + blockIdx.x * blockDim.x;
    	int y = threadIdx.y + blockIdx.y * blockDim.y;

	if(A[x][y] == 5){
		atomicAdd(a,1);
		__syncthreads();
	}
}
__global__ void act_art (double **A)
{	//i is a row, j is column
	int i = threadIdx.x + blockIdx.x * blockDim.x;
    	int j = threadIdx.y + blockIdx.y * blockDim.y;
	int u,d,l,r;	//up, down, left, right
//	A[x][y] = A[l][y] + A[r][y];
	if(i<N && j<N){
	u = fmodf((i-1 + N) , N);
	d = fmodf((i+1 + N) , N);
	l = fmodf((j-1 + N) , N);
	r = fmodf((j+1 + N) , N);
	
	A[i][j] = A[u][j];
	}
}

int main(void)
{       
        double** h_A = Make2DDoubleArray(N, N);
	double **d_A;
	int h_demand[1];
	int *d_demand;
        double *h_temp[N];	//for h_A
        int i;
	dim3    blocks(N/4,N/4);		//2nd day revise
	dim3    threads(4,4);			//2nd day revise
	h_demand[0] = 0;
//	init2D(h_A);
//	printf("\n\n============CPU===============\n");
//	showxx(h_A);
        
	// Create 2D Array on device
	// Do not destroy h_temp[]
        HANDLE_ERROR(cudaMalloc((void **)&d_A, N*sizeof(double *)));
        for(i=0; i<N; i++)
        {
           HANDLE_ERROR(cudaMalloc( (void **)&h_temp[i], N*sizeof(double)))	;
        }
        HANDLE_ERROR(cudaMemcpy(d_A, h_temp, 
				N*sizeof(double *), 
				cudaMemcpyHostToDevice));
				
	// Allocate d_demand
	HANDLE_ERROR( cudaMalloc( (void**)&d_demand, 1 * sizeof(int) ) );
	// Copy h_demand to d_demand
 	HANDLE_ERROR( cudaMemcpy( d_demand, h_demand, 1 * sizeof(int),
                              cudaMemcpyHostToDevice ) );

        printf("\n\n============GPU===============\n");
        
	adda<<<blocks,threads>>>(d_A);
//	act_art<<<blocks,threads>>>(d_A);
	nupspin<<<blocks,threads>>>(d_A,d_demand);
		
	//copy back to host
	for(i=0; i<N; i++)
        {
              HANDLE_ERROR(cudaMemcpy(h_A[i], 
					h_temp[i], 
					N*sizeof(double), 
					cudaMemcpyDeviceToHost));
        }
        showxx(h_A);
 	// copy the array 'd_demand' back from the GPU to the CPU
 	HANDLE_ERROR( cudaMemcpy( h_demand, d_demand, 1*sizeof(int),
                              cudaMemcpyDeviceToHost ) );
   	printf("\n\ndemand = %d\n",h_demand[0]);
        
        for (i = 0; i < N; i++){
                free(h_A[i]);
        }
        free(h_A);
        return 0;
}
